
/**************************************************************************
 * This file is part of Celera Assembler, a software program that
 * assembles whole-genome shotgun reads into contigs and scaffolds.
 * Copyright (C) 1999-2004, Applera Corporation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received (LICENSE.txt) a copy of the GNU General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *************************************************************************/

#ifndef MULTIALIGNSTORE_H
#define MULTIALIGNSTORE_H

static const char *rcsid_MULTIALIGNSTORE_H = "$Id: MultiAlignStore_CNS.h,v 1.15 2008/10/08 22:02:57 brianwalenz Exp $";

#include "AS_global.h"
#include "MultiAlign.h"

typedef struct {
  uint32        maMax;
  MultiAlignT **maPtr;
} MultiAlignStoreT;


MultiAlignStoreT *CreateMultiAlignStoreT(void);
void              DeleteMultiAlignStoreT(MultiAlignStoreT *multiAlignStore);
void              ClearMultiAlignStoreT(MultiAlignStoreT *multiAlignStore);

void              SetMultiAlignInStore(MultiAlignStoreT *multiAlignStore, int index, MultiAlignT *multiAlign);
MultiAlignT      *GetMultiAlignInStore(MultiAlignStoreT *multiAlignStore,  int index);
void              RemoveMultiAlignFromStore(MultiAlignStoreT *mas, int index);

#endif
